#include "memoryleaker.h"

MemoryLeaker::MemoryLeaker(QObject *parent)
    : QObject(parent)
    , m_handle(INVALID_HANDLE_VALUE)
    , m_notifier(0)
{
    m_notifier = new QWinOverlappedIoNotifier(this);
    connect(m_notifier, &QWinOverlappedIoNotifier::notified, this, &MemoryLeaker::completeAsyncRead);
}

void MemoryLeaker::exec(const QString &fileToOpen)
{
    open(fileToOpen);

    forever {
        const OVERLAPPED *overlapped = m_notifier->waitForAnyNotified(-1);
        if (!overlapped) {
            qDebug() << "Null ovl";
        } else if (overlapped != &m_overlapped) {
            qDebug() << "Wrong ovl pointer:" << overlapped;
        }
    }
}

void MemoryLeaker::completeAsyncRead(DWORD numberOfBytes, DWORD errorCode, OVERLAPPED *overlapped)
{
    if (errorCode != NO_ERROR) {
        qDebug() << "Read error:" << errorCode;
    } else if (numberOfBytes != 1) {
        qDebug() << "Wrong bytes read:" << numberOfBytes;
    } else if (overlapped != &m_overlapped) {
        qDebug() << "Wrong ovl pointer:" << overlapped;
    } else {
        startAsyncRead();
    }
}

void MemoryLeaker::open(const QString &fileToOpen)
{
    m_handle = ::CreateFile(
                reinterpret_cast<const wchar_t*>(fileToOpen.utf16()),
                GENERIC_READ,
                FILE_SHARE_READ,
                NULL,
                OPEN_EXISTING,
                FILE_FLAG_OVERLAPPED,
                NULL
                );

    if (m_handle == INVALID_HANDLE_VALUE) {
        qDebug() << "Open error:" << ::GetLastError();
        return;
    }

    m_notifier->setHandle(m_handle);
    m_notifier->setEnabled(true);

    startAsyncRead();
}

void MemoryLeaker::startAsyncRead()
{
    ::ZeroMemory(&m_overlapped, sizeof(m_overlapped));
    if (!::ReadFile(m_handle, &m_c, 1, NULL, &m_overlapped)
            && (::GetLastError() != ERROR_IO_PENDING)) {
        qDebug() << "Read error:" << ::GetLastError();
    }
}
